︠26e6b623-28d4-4897-8a01-69c90e57ce4c︠
time ecm.factor((2^197 + 1)/3)
︡d47f0691-72b3-47c6-9a18-b8e9fa8d28d2︡{"stdout": "[197002597249, 1348959352853811313, 251951573867253012259144010843]\nTime: CPU 0.16 s, Wall: 12.18 s"}︡
︠5174c368-42e4-4110-8599-eb7c60f9f044︠
time factor((2^197 + 1)/3)
︡ed617d23-0182-41de-a202-b14ce889e2ec︡{"stdout": "197002597249 * 1348959352853811313 * 251951573867253012259144010843\nTime: CPU 2.54 s, Wall: 2.86 s"}︡
︠27599138-548c-46f8-adf4-f5b4fd4b0f5ei︠
%html
<p>sage has a built-in "elliptic curve factoring" program ecm. &nbsp;We can do some ecm factoring by hand. &nbsp;We first create an RSF modulus $N$ that we want to factor and then produce a "reasonably random'' point on a random elliptic curve mod $N$.</p>

︡1477e9a6-8fcf-4fa7-812d-3c9ad6d1d7b2︡{"html": "<p>sage has a built-in \"elliptic curve factoring\" program ecm. &nbsp;We can do some ecm factoring by hand. &nbsp;We first create an RSF modulus $N$ that we want to factor and then produce a \"reasonably random'' point on a random elliptic curve mod $N$.</p>"}︡
︠858537b8-a3ea-497a-9f22-e622841393b5︠
N=next_prime(1667)*next_prime(2234); N; R=Integers(N); R.is_field = lambda : True
︡f5f8435a-1736-43fc-9745-cb870b0d9a6a︡{"stdout": "3733553"}︡
︠8c340834-fd10-4702-a0c8-c483be24568ai︠
%html
<p>Unfortunately, we have to temporarily trick sage into thinking that $R$ is a field (which is isn't).</p>

︡067f09b8-f4d7-4035-93ab-9f3cb7fcf3a9︡{"html": "<p>Unfortunately, we have to temporarily trick sage into thinking that $R$ is a field (which is isn't).</p>"}︡
︠bf78c47c-6746-4f15-9875-386bd5580d6b︠
a=R.random_element(); b=R.random_element(); c=R.random_element();
d=b^2-a^3-c*a; [a,b,c,d]; E=EllipticCurve([c,d]); E
︡6f3ddf16-93fe-4f8c-92f4-69b738917873︡{"stdout": "[994039, 2552712, 898226, 758912]\nElliptic Curve defined by y^2 = x^3 + 898226*x + 758912 over Ring of integers modulo 3733553"}︡
︠d3273023-c921-41d1-bdc7-1c7f7a56a89di︠
%html
<p>Note that we have chosen $d$ in the coefficient of the elliptic curve so that $(a,b)$ is a point on the curve. &nbsp;It is hard to construct random points on given curves because you don't know whether the $y^2$ for an $x$ that you choose is actually a square.</p>

︡155c877e-b6b7-488a-97ab-928611704689︡{"html": "<p>Note that we have chosen $d$ in the coefficient of the elliptic curve so that $(a,b)$ is a point on the curve. &nbsp;It is hard to construct random points on given curves because you don't know whether the $y^2$ for an $x$ that you choose is actually a square.</p>"}︡
︠a2e3c48b-e5fd-435b-9462-4f2398099c6a︠
P=E([a,b]); P
︡116a12ec-5fd1-408e-b0ea-d4d7d9f27be5︡{"stdout": "(994039 : 2552712 : 1)"}︡
︠a76c748f-1e46-4004-bf26-c5527ca7d59bi︠
%html
<p>Note that the third coordinate of $P$ is $1$; $P$ is `"completely affine.'' &nbsp;However, some multiple of $P$ is likely to be the point at $\infty$ modulo one of the prime factors of $N$ but not the other factor of $N$. &nbsp;If this occurs, we can factor $N$.</p>

︡4680f4a9-c2e7-4ba1-8c9b-3dc319c3cda3︡{"html": "<p>Note that the third coordinate of $P$ is $1$; $P$ is `\"completely affine.'' &nbsp;However, some multiple of $P$ is likely to be the point at $\\infty$ modulo one of the prime factors of $N$ but not the other factor of $N$. &nbsp;If this occurs, we can factor $N$.</p>"}︡
︠6718e880-0e52-4403-be05-37f230b8dfb4︠
factorial(7)*P
︡7c0a7114-68da-4c46-8f33-42aed99aa4e6︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_41.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"ZmFjdG9yaWFsKDcpKlA=\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/private/var/folders/ck/ckRR1gdE2RWjAk+1YtnJGU+++TI/-Tmp-/tmprSSXiw/___code___.py\", line 3, in <module>\n    exec compile(ur'factorial(_sage_const_7 )*P' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"element.pyx\", line 1398, in sage.structure.element.RingElement.__mul__ (sage/structure/element.c:11337)\n  File \"coerce.pyx\", line 709, in sage.structure.coerce.CoercionModel_cache_maps.bin_op (sage/structure/coerce.c:6103)\n  File \"coerce_actions.pyx\", line 453, in sage.structure.coerce_actions.IntegerMulAction._call_ (sage/structure/coerce_actions.c:6280)\n  File \"coerce_actions.pyx\", line 518, in sage.structure.coerce_actions.fast_mul_long (sage/structure/coerce_actions.c:6967)\n  File \"element.pyx\", line 927, in sage.structure.element.ModuleElement.__iadd__ (sage/structure/element.c:7710)\n  File \"element.pyx\", line 919, in sage.structure.element.ModuleElement._add_ (sage/structure/element.c:7574)\n  File \"/Users/kribet/Desktop/sage/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_point.py\", line 625, in _add_\n    raise ZeroDivisionError, \"Inverse of %s does not exist\"%(x1-x2)\nZeroDivisionError: Inverse of 265371 does not exist"}︡
︠2b65456a-9777-4577-8715-7395dbab8e44i︠
%html
<p>When you see a ZeroDivisionError you know that something is up.</p>

︡314dab1a-58e8-42da-b519-e940690affb0︡{"html": "<p>When you see a ZeroDivisionError you know that something is up.</p>"}︡
︠6bdb4f04-e7fc-48bc-8cc2-4dd067d9f099︠
gcd(265371,N)
︡498dbac9-3d4a-4b0a-b61d-c472dec86131︡{"stdout": "1669"}︡
︠11500553-62f8-4b19-9a45-733e265193f9︠
N/_
︡a2101849-33e8-46c1-bfb4-287327aa8296︡{"stdout": "2237"}︡
︠9943d7e4-bc70-456d-a4ba-ed3cfd4e0451︠
R = Integers(1669); E= EllipticCurve(R,[898226, 758912]); P = E([994039, 2552712])
︡e7c2be1d-e4e8-45c6-98cd-19fd025bb14b︡︡
︠bf486e04-b9ac-449f-b672-3bcbd262bac3︠
P.order()
︡0393160a-386b-4a0c-a0a8-642624ded373︡{"stdout": "70"}︡
︠53d55f8a-1fa4-4fe2-9f55-caf9f2de6300︠
R = Integers(2237); E= EllipticCurve(R,[898226, 758912]); P = E([994039, 2552712])
︡78aaa9e6-fbe8-4451-a28b-70255e2e6373︡︡
︠919eedff-c7cf-4431-9ba8-5cbae440a91e︠
P.order()
︡c46b79e3-4679-4f6a-befc-6b7ab0907f62︡{"stdout": "2213"}︡
︠4557a6d5-5368-434b-87a4-495a933b85e9i︠
%html
<p>Stein's code for a simple ecm routine is in his "Elementary number theory" book (available for download), p. 134. &nbsp;Here it comes.</p>

︡f35edafc-a885-451b-8196-454978f20218︡{"html": "<p>Stein's code for a simple ecm routine is in his \"Elementary number theory\" book (available for download), p. 134. &nbsp;Here it comes.</p>"}︡
︠73de182f-f4e4-4dc2-baac-e46b5f3e9e08︠
def ecm(N,B=10^3,trials=10):
    m = prod([p^int(math.log(B)/math.log(p)) for p in prime_range(B+1)])
    R = Integers(N)
    R.is_field = lambda: True
    for _ in range(trials):
        while True:
            a = R.random_element()
            if gcd(4*a.lift()^3 + 27, N) == 1: break
        try:
            m * EllipticCurve([a, 1])([0,1])
        except ZeroDivisionError, msg:
            # msg: "Inverse of <int> does not exist"
            return gcd(Integer(str(msg).split()[2]), N)
    return 1
︡79a47f5e-5da3-4511-b7b1-d8c06be4be5c︡︡
︠32103b7a-4bb0-49d0-93df-95f607cd6725︠
ecm(12345644525857247889249058724507)
︡9d58e10f-511f-4f80-8be3-f451bc708f11︡{"stdout": "2011"}︡
︠f3783bfc-6fae-4f26-bec3-2a8ab83478dai︠
%html
<p>Sato-Tate:</p>

︡c54c4302-d081-4383-95ca-90e85a296c5e︡{"html": "<p>Sato-Tate:</p>"}︡
︠3e248563-98f0-4649-89bd-dd54c30e1f67a︠
#%auto
def sato_tate(E, N):
    return [acos(E.ap(p)/(2*sqrt(p))) for p in prime_range(N+1) if N%p != 0]
︡8bdb2028-226f-4d63-bdaa-f8aa8c12a22e︡︡
︠f7699bd6-ed6e-4546-b262-120c249db481︠
def dist(v, b, left=float(0), right=float(pi)):
    """
    We divide the interval between left (default: 0) and 
    right (default: pi) up into b bins.
   
    For each number in v (which must left and right), 
    we find which bin it lies in and add this to a counter.
    This function then returns the bins and the number of
    elements of v that lie in each one. 

    ALGORITHM: To find the index of the bin that a given 
    number x lies in, we multiply x by b/length and take the 
    floor. 
    """
    length = right - left
    normalize = float(b/length)
    vals = {}
    d = dict([(i,0) for i in range(b)])
    for x in v:
        n = int(normalize*(float(x)-left))
        d[n] += 1
    return d, len(v)
︡7169c809-6cde-47c6-a857-85e2e6ace4a1︡︡
︠0a6a77ec-066f-4214-a1f9-ddde0e7fdc0ca︠
#%auto
def graph(d, b, num=5000, left=float(0), right=float(pi)):
    s = Graphics()
    left = float(left); right = float(right)
    length = right - left
    w = length/b
    k = 0
    for i, n in d.iteritems():
        k += n
        # ith bin has n objects in it.
        s += polygon([(w*i+left,0), (w*(i+1)+left,0), \
                     (w*(i+1)+left, n/(num*w)), (w*i+left, n/(num*w))],\
                     rgbcolor=(0,0,0.5))
    return s
︡e8538f15-e5a2-4081-ad57-f0b85555f9fb︡︡
︠a53b9316-4c0c-4c98-add4-d38ca176126f︠
def sin2():
    PI = float(pi)
    return plot(lambda x: (2/PI)*math.sin(x)^2, 0,pi, plot_points=200, \
        rgbcolor=(0.3,0.1,0.1), thickness=2)
︡d88de77a-1c9b-4bf3-925d-0be03910d83f︡︡
︠c45d9d7a-e91d-4aa5-8b21-a9cb94755998a︠
#%auto
def graph_ellcurve(E, b=10, num=5000):
    v = sato_tate(E, num)
    d, total_number_of_points = dist(v,b)
    return graph(d, b, total_number_of_points) + sin2()
︡290f1437-1e55-4f9d-a589-d591e6c11247︡︡
︠94ea6e9e-09ef-4706-aece-b3c21252ff56︠
g = graph_ellcurve(EllipticCurve('11a'),200,150000)
show(g)
︡85a577a4-4bf8-4879-b46d-c6e7fe9c22c5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠49a098f6-4b46-44e5-8057-3b8865221ab8i︠
%html
<p>Checking problem 5.3:</p>

︡6a21b825-d5df-40fe-a5ff-0a8170f45065︡{"html": "<p>Checking problem 5.3:</p>"}︡
︠426f3116-4b37-44a0-bf80-df680f055489︠
var('e1'); var('e2'); e3 = -e1 - e2; B = -e1*e2*e3; A = e1*e2+e2*e3+e1*e3
︡c6e76c9f-c82a-4fb5-a1a5-9ea17cbc4493︡{"stdout": "e1\ne2"}︡
︠8a8e9ce4-e690-4ab0-9151-fea9e9ac68dc︠
(e1-e2)^2*(e1-e3)^2*(e2-e3)^2 + 4*A^3 + 27*B^2
︡00471c6e-928b-4352-af01-848137574125︡{"stdout": "(e1 - e2)^2*(e1 + 2*e2)^2*(2*e1 + e2)^2 + 27*(e1 + e2)^2*e1^2*e2^2 - 4*((e1 + e2)*e1 + (e1 + e2)*e2 - e1*e2)^3"}︡
︠541535ba-a1f9-479a-8e3f-248cc8286bef︠
expand(_)
︡1dc0764f-81e6-4d0b-98a3-e686c390acc4︡{"stdout": "0"}︡
︠feb8ed95-bb44-497e-9da3-9c308e4478aa︠
R=Integers(next_prime(12345678912));   a=R.random_element(); b=R.random_element(); c=R.random_element();
d=b^2-a^3-c*a; [a,b,c,d]; E=EllipticCurve([c,d]); E; E([a,b]).order().factor()
︡33869c2f-ba9c-4a4d-8d06-89f4a01d0494︡{"stdout": "[7498018392, 7507292418, 12337758188, 9018389178]\nElliptic Curve defined by y^2 = x^3 + 12337758188*x + 9018389178 over Ring of integers modulo 12345678923\n7 * 19 * 41 * 566011"}︡
︠d9875df4-73d5-4d42-83c1-1158ae5f1abf︠
time EllipticCurve('4077a').congruence_number()
︡0c565438-a96c-45e2-8233-20bad856c4ea︡︡
︠f29b63d7-1e21-4703-8e96-45119d33a9e6︠
EllipticCurve('5077a').integral_points?
︡6dd55239-94e7-4eb9-91d8-5f5dce2b11ad︡{"html": "<!--notruncate-->\nNo object '.integral_points' currently defined.\n"}︡
︠0bcb300f-a7f6-4fc4-8b0c-683412f30aeb︠
E=EllipticCurve('11a')
︡b68d6394-55b8-4e57-9707-5f293c2a44d3︡︡
︠6b9be312-5e57-4d34-b35c-686f3fd50109︠
E.integral_points?
︡91020ef4-f690-409a-b34a-95851b7d1b04︡{"html": "<!--notruncate-->\n<div class=\"docstring\">\n    \n  <p><strong>File:</strong> /usr/local/sage/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_rational_field.py</p>\n<p><strong>Type:</strong> &lt;type &#8216;instancemethod&#8217;&gt;</p>\n<p><strong>Definition:</strong> E.integral_points(mw_base=&#8217;auto&#8217;, both_signs=False, verbose=False)</p>\n<p><strong>Docstring:</strong></p>\n<blockquote>\n<p>Computes all integral points (up to sign) on this elliptic curve.</p>\n<p>INPUT:</p>\n<ul class=\"simple\">\n<li><tt class=\"docutils literal\"><span class=\"pre\">mw_base</span></tt> - list of EllipticCurvePoint generating\nthe Mordell-Weil group of E (default: &#8216;auto&#8217; - calls E.gens())</li>\n<li><tt class=\"docutils literal\"><span class=\"pre\">both_signs</span></tt> - True/False (default False): if\nTrue the output contains both P and -P, otherwise only one of each\npair.</li>\n<li><tt class=\"docutils literal\"><span class=\"pre\">verbose</span></tt> - True/False (default False): if True,\nsome details of the computation are output</li>\n</ul>\n<p>OUTPUT: A sorted list of all the integral points on E (up to sign\nunless both_signs is True)</p>\n<div class=\"admonition note\">\n<p class=\"first admonition-title\">Note</p>\n<p class=\"last\">The complexity increases exponentially in the rank of curve\nE. The computation time (but not the output!) depends on\nthe Mordell-Weil basis. If mw_base is given but is not a\nbasis for the Mordell-Weil group (modulo torsion), integral\npoints which are not in the subgroup generated by the given\npoints will almost certainly not be listed.</p>\n</div>\n<p>EXAMPLES: A curve of rank 3 with no torsion points</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">=</span><span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">1</span><span class=\"p\">,</span><span class=\"o\">-</span><span class=\"mf\">7</span><span class=\"p\">,</span><span class=\"mf\">6</span><span class=\"p\">])</span>\n<span class=\"gp\">sage: </span><span class=\"n\">P1</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">2</span><span class=\"p\">,</span><span class=\"mf\">0</span><span class=\"p\">));</span> <span class=\"n\">P2</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"o\">-</span><span class=\"mf\">1</span><span class=\"p\">,</span><span class=\"mf\">3</span><span class=\"p\">));</span> <span class=\"n\">P3</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">4</span><span class=\"p\">,</span><span class=\"mf\">6</span><span class=\"p\">))</span>\n<span class=\"gp\">sage: </span><span class=\"n\">a</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">([</span><span class=\"n\">P1</span><span class=\"p\">,</span><span class=\"n\">P2</span><span class=\"p\">,</span><span class=\"n\">P3</span><span class=\"p\">]);</span> <span class=\"n\">a</span>\n<span class=\"go\">[(-3 : 0 : 1), (-2 : 3 : 1), (-1 : 3 : 1), (0 : 2 : 1), (1 : 0 : 1), (2 : 0 : 1), (3 : 3 : 1), (4 : 6 : 1), (8 : 21 : 1), (11 : 35 : 1), (14 : 51 : 1), (21 : 95 : 1), (37 : 224 : 1), (52 : 374 : 1), (93 : 896 : 1), (342 : 6324 : 1), (406 : 8180 : 1), (816 : 23309 : 1)]</span>\n</pre></div>\n</div>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">a</span> <span class=\"o\">=</span> <span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">([</span><span class=\"n\">P1</span><span class=\"p\">,</span><span class=\"n\">P2</span><span class=\"p\">,</span><span class=\"n\">P3</span><span class=\"p\">],</span> <span class=\"n\">verbose</span><span class=\"o\">=</span><span class=\"bp\">True</span><span class=\"p\">)</span>\n<span class=\"go\">Using mw_basis  [(2 : 0 : 1), (3 : -4 : 1), (8 : -22 : 1)]</span>\n<span class=\"go\">e1,e2,e3:  -3.0124303725933... 1.0658205476962... 1.94660982489710</span>\n<span class=\"go\">Minimal eigenvalue of height pairing matrix:  0.63792081458500...</span>\n<span class=\"go\">x-coords of points on compact component with  -3 &lt;=x&lt;= 1</span>\n<span class=\"go\">[-3, -2, -1, 0, 1]</span>\n<span class=\"go\">x-coords of points on non-compact component with  2 &lt;=x&lt;= 6</span>\n<span class=\"go\">[2, 3, 4]</span>\n<span class=\"go\">starting search of remaining points using coefficient bound  5</span>\n<span class=\"go\">x-coords of extra integral points:</span>\n<span class=\"go\">[2, 3, 4, 8, 11, 14, 21, 37, 52, 93, 342, 406, 816]</span>\n<span class=\"go\">Total number of integral points: 18</span>\n</pre></div>\n</div>\n<p>It is not necessary to specify mw_base; if it is not provided,\nthen the Mordell-Weil basis must be computed, which may take\nmuch longer.</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">=</span><span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">1</span><span class=\"p\">,</span><span class=\"o\">-</span><span class=\"mf\">7</span><span class=\"p\">,</span><span class=\"mf\">6</span><span class=\"p\">])</span>\n<span class=\"gp\">sage: </span><span class=\"n\">a</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">(</span><span class=\"n\">both_signs</span><span class=\"o\">=</span><span class=\"bp\">True</span><span class=\"p\">);</span> <span class=\"n\">a</span>\n<span class=\"go\">[(-3 : -1 : 1), (-3 : 0 : 1), (-2 : -4 : 1), (-2 : 3 : 1), (-1 : -4 : 1), (-1 : 3 : 1), (0 : -3 : 1), (0 : 2 : 1), (1 : -1 : 1), (1 : 0 : 1), (2 : -1 : 1), (2 : 0 : 1), (3 : -4 : 1), (3 : 3 : 1), (4 : -7 : 1), (4 : 6 : 1), (8 : -22 : 1), (8 : 21 : 1), (11 : -36 : 1), (11 : 35 : 1), (14 : -52 : 1), (14 : 51 : 1), (21 : -96 : 1), (21 : 95 : 1), (37 : -225 : 1), (37 : 224 : 1), (52 : -375 : 1), (52 : 374 : 1), (93 : -897 : 1), (93 : 896 : 1), (342 : -6325 : 1), (342 : 6324 : 1), (406 : -8181 : 1), (406 : 8180 : 1), (816 : -23310 : 1), (816 : 23309 : 1)]</span>\n</pre></div>\n</div>\n<p>An example with negative discriminant:</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">EllipticCurve</span><span class=\"p\">(</span><span class=\"s\">&#39;900d1&#39;</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">()</span>\n<span class=\"go\">[(-11 : 27 : 1), (-4 : 34 : 1), (4 : 18 : 1), (16 : 54 : 1)]</span>\n</pre></div>\n</div>\n<p>Another example with rank 5 and no torsion points</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">=</span><span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"o\">-</span><span class=\"mf\">879984</span><span class=\"p\">,</span><span class=\"mf\">319138704</span><span class=\"p\">])</span>\n<span class=\"gp\">sage: </span><span class=\"n\">P1</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">540</span><span class=\"p\">,</span><span class=\"mf\">1188</span><span class=\"p\">));</span> <span class=\"n\">P2</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">576</span><span class=\"p\">,</span><span class=\"mf\">1836</span><span class=\"p\">))</span>\n<span class=\"gp\">sage: </span><span class=\"n\">P3</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">468</span><span class=\"p\">,</span><span class=\"mf\">3132</span><span class=\"p\">));</span> <span class=\"n\">P4</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">612</span><span class=\"p\">,</span><span class=\"mf\">3132</span><span class=\"p\">))</span>\n<span class=\"gp\">sage: </span><span class=\"n\">P5</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">point</span><span class=\"p\">((</span><span class=\"mf\">432</span><span class=\"p\">,</span><span class=\"mf\">4428</span><span class=\"p\">))</span>\n<span class=\"gp\">sage: </span><span class=\"n\">a</span><span class=\"o\">=</span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">([</span><span class=\"n\">P1</span><span class=\"p\">,</span><span class=\"n\">P2</span><span class=\"p\">,</span><span class=\"n\">P3</span><span class=\"p\">,</span><span class=\"n\">P4</span><span class=\"p\">,</span><span class=\"n\">P5</span><span class=\"p\">]);</span> <span class=\"nb\">len</span><span class=\"p\">(</span><span class=\"n\">a</span><span class=\"p\">)</span>  <span class=\"c\"># long time (400s!)</span>\n<span class=\"go\">54</span>\n</pre></div>\n</div>\n<p>The bug reported on trac #4525 is now fixed:</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">EllipticCurve</span><span class=\"p\">(</span><span class=\"s\">&#39;91b1&#39;</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">()</span>\n<span class=\"go\">[(-1 : 3 : 1), (1 : 0 : 1), (3 : 4 : 1)]</span>\n</pre></div>\n</div>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"p\">[</span><span class=\"nb\">len</span><span class=\"p\">(</span><span class=\"n\">e</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">(</span><span class=\"n\">both_signs</span><span class=\"o\">=</span><span class=\"bp\">False</span><span class=\"p\">))</span> <span class=\"k\">for</span> <span class=\"n\">e</span> <span class=\"ow\">in</span> <span class=\"n\">cremona_curves</span><span class=\"p\">([</span><span class=\"mf\">11.</span><span class=\"o\">.</span><span class=\"mf\">100</span><span class=\"p\">])]</span> <span class=\"c\"># long time</span>\n<span class=\"go\">[2, 0, 2, 3, 2, 1, 3, 0, 2, 4, 2, 4, 3, 0, 0, 1, 2, 1, 2, 0, 2, 1, 0, 1, 3, 3, 1, 1, 4, 2, 3, 2, 0, 0, 5, 3, 2, 2, 1, 1, 1, 0, 1, 3, 0, 1, 0, 1, 1, 3, 6, 1, 2, 2, 2, 0, 0, 2, 3, 1, 2, 2, 1, 1, 0, 3, 2, 1, 0, 1, 0, 1, 3, 3, 1, 1, 5, 1, 0, 1, 1, 0, 1, 2, 0, 2, 0, 1, 1, 3, 1, 2, 2, 4, 4, 2, 1, 0, 0, 5, 1, 0, 1, 2, 0, 2, 2, 0, 0, 0, 1, 0, 3, 1, 5, 1, 2, 4, 1, 0, 1, 0, 1, 0, 1, 0, 2, 2, 0, 0, 1, 0, 1, 1, 4, 1, 0, 1, 1, 0, 4, 2, 0, 1, 1, 2, 3, 1, 1, 1, 1, 6, 2, 1, 1, 0, 2, 0, 6, 2, 0, 4, 2, 2, 0, 0, 1, 2, 0, 2, 1, 0, 3, 1, 2, 1, 4, 6, 3, 2, 1, 0, 2, 2, 0, 0, 5, 4, 1, 0, 0, 1, 0, 2, 2, 0, 0, 2, 3, 1, 3, 1, 1, 0, 1, 0, 0, 1, 2, 2, 0, 2, 0, 0, 1, 2, 0, 0, 4, 1, 0, 1, 1, 0, 1, 2, 0, 1, 4, 3, 1, 2, 2, 1, 1, 1, 1, 6, 3, 3, 3, 3, 1, 1, 1, 1, 1, 0, 7, 3, 0, 1, 3, 2, 1, 0, 3, 2, 1, 0, 2, 2, 6, 0, 0, 6, 2, 2, 3, 3, 5, 5, 1, 0, 6, 1, 0, 3, 1, 1, 2, 3, 1, 2, 1, 1, 0, 1, 0, 1, 0, 5, 5, 2, 2, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1]</span>\n</pre></div>\n</div>\n<p>The bug reported at #4897 is now fixed:</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"p\">[</span><span class=\"n\">P</span><span class=\"p\">[</span><span class=\"mf\">0</span><span class=\"p\">]</span> <span class=\"k\">for</span> <span class=\"n\">P</span> <span class=\"ow\">in</span> <span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"mf\">0</span><span class=\"p\">,</span><span class=\"o\">-</span><span class=\"mf\">468</span><span class=\"p\">,</span><span class=\"mf\">2592</span><span class=\"p\">])</span><span class=\"o\">.</span><span class=\"n\">integral_points</span><span class=\"p\">()]</span>\n<span class=\"go\">[-24, -18, -14, -6, -3, 4, 6, 18, 21, 24, 36, 46, 102, 168, 186, 381, 1476, 2034, 67246]</span>\n</pre></div>\n</div>\n<div class=\"admonition note\">\n<p class=\"first admonition-title\">Note</p>\n<p class=\"last\">This function uses the algorithm given in [Co1].</p>\n</div>\n<p>REFERENCES:</p>\n<ul class=\"simple\">\n<li>[Co1] Cohen H., Number Theory Vol I: Tools and Diophantine\nEquations GTM 239, Springer 2007</li>\n</ul>\n<p>AUTHORS:</p>\n<ul class=\"simple\">\n<li>Michael Mardaus (2008-07)</li>\n<li>Tobias Nagel (2008-07)</li>\n<li>John Cremona (2008-07)</li>\n</ul>\n</blockquote>\n\n\n</div>\n"}︡
︠fe978758-7f72-487a-91d6-e16530b97898︠
EllipticCurve('56b1').modular_degree()
︡6b8fe0be-e03a-4e9b-b415-c3e3a93e8d01︡{"stdout": "4"}︡
︠bb002eea-124e-4816-8439-d0309bd12b48︠
1+1
︡1264baf6-4915-4022-aeb3-b47571e1bf1f︡{"stdout": "2"}︡
